searchNodes=[{"type":"module","title":"Redlock","doc":"This library is an implementation of Redlock (Redis destributed lock) Redlock Usage resource = &quot;example_key: \#{ user_id } &quot; lock_exp_sec = 10 case Redlock . lock ( resource , lock_exp_sec ) do { :ok , mutex } -&gt; # some other code which write and read on RDBMS, KVS or other storage # call unlock finally Redlock . unlock ( resource , mutex ) :error -&gt; Logger . error &quot;failed to lock resource. maybe redis connection got trouble.&quot; { :error , :system_error } end Or you can use transaction function def my_function ( ) do # do something, and return {:ok, :my_result} or {:error, :my_error} end def execute_with_lock ( ) do resource = &quot;example_key: \#{ user_id } &quot; lock_exp_sec = 10 case Redlock . transaction ( resource , lock_exp_sec , &amp; my_function / 0 ) do { :ok , :my_result } -&gt; Logger . info &quot;this is the return-value of my_function/0&quot; :ok { :error , :my_error } -&gt; Logger . info &quot;this is the return-value of my_function/0&quot; :error { :error , :lock_failure } -&gt; Logger . info &quot;if locking has failed, Redlock returns this error&quot; :error end end Setup children = [ # other workers/supervisors { Redlock , redlock_opts } ] Supervisor . start_link ( children , strategy : :one_for_one ) Options Single Node Mode readlock_opts = [ pool_size : 2 , drift_factor : 0.01 , max_retry : 3 , retry_interval_base : 300 , retry_interval_max : 3_000 , reconnection_interval_base : 500 , reconnection_interval_max : 5_000 , # you must set odd number of server servers : [ [ host : &quot;redis1.example.com&quot; , port : 6379 ] , [ host : &quot;redis2.example.com&quot; , port : 6379 ] , [ host : &quot;redis3.example.com&quot; , port : 6379 ] ] ] pool_size : pool_size of number of connection pool for each Redis master node, default is 2 drift_factor : number used for calculating validity for results, see https://redis.io/topics/distlock for more detail. max_retry : how many times you want to retry if you failed to lock resource. retry_interval_max : (milliseconds) used to decide how long you want to wait untill your next try after a lock-failure. retry_interval_base : (milliseconds) used to decide how long you want to wait untill your next try after a lock-failure. reconnection_interval_base : (milliseconds) used to decide how long you want to wait until your next try after a redis-disconnection reconnection_interval_max : (milliseconds) used to decide how long you want to wait until your next try after a redis-disconnection servers : host, port and auth settings for each redis-server. this amount must be odd. Auth can be omitted if no authentication is reaquired How long you want to wait until your next try after a redis-disconnection or lock-failure the interval(milliseconds) is decided by following calculation. min(XXX_interval_max, (XXX_interval_base (attempts_count * 2))) Cluster Mode readlock_opts = [ pool_size : 2 , drift_factor : 0.01 , max_retry : 3 , retry_interval_base : 300 , retry_interval_max : 3_000 , reconnection_interval_base : 500 , reconnection_interval_max : 5_000 , cluster : [ # first node [ # you must set odd number of server [ host : &quot;redis1.example.com&quot; , port : 6379 ] , [ host : &quot;redis2.example.com&quot; , port : 6379 ] , [ host : &quot;redis3.example.com&quot; , port : 6379 ] ] , # second node [ # you must set odd number of server [ host : &quot;redis4.example.com&quot; , port : 6379 ] , [ host : &quot;redis5.example.com&quot; , port : 6379 ] , [ host : &quot;redis6.example.com&quot; , port : 6379 ] ] , # third node [ # you must set odd number of server [ host : &quot;redis7.example.com&quot; , port : 6379 ] , [ host : &quot;redis8.example.com&quot; , port : 6379 ] , [ host : &quot;redis9.example.com&quot; , port : 6379 ] ] ] ] Set cluster option instead of servers , then Redlock works as cluster mode. When you want to lock some resource, Redlock chooses a node depends on a resource key with consistent-hashing.","ref":"Redlock.html"},{"type":"function","title":"Redlock.child_spec/1","doc":"","ref":"Redlock.html#child_spec/1"},{"type":"function","title":"Redlock.extend/3","doc":"","ref":"Redlock.html#extend/3"},{"type":"function","title":"Redlock.lock/2","doc":"","ref":"Redlock.html#lock/2"},{"type":"function","title":"Redlock.transaction/3","doc":"","ref":"Redlock.html#transaction/3"},{"type":"function","title":"Redlock.unlock/2","doc":"","ref":"Redlock.html#unlock/2"},{"type":"module","title":"Redlock.Command","doc":"","ref":"Redlock.Command.html"},{"type":"function","title":"Redlock.Command.extend/5","doc":"","ref":"Redlock.Command.html#extend/5"},{"type":"function","title":"Redlock.Command.extend_hash/0","doc":"","ref":"Redlock.Command.html#extend_hash/0"},{"type":"function","title":"Redlock.Command.install_scripts/1","doc":"","ref":"Redlock.Command.html#install_scripts/1"},{"type":"function","title":"Redlock.Command.lock/5","doc":"","ref":"Redlock.Command.html#lock/5"},{"type":"function","title":"Redlock.Command.unlock/3","doc":"","ref":"Redlock.Command.html#unlock/3"},{"type":"function","title":"Redlock.Command.unlock_hash/0","doc":"","ref":"Redlock.Command.html#unlock_hash/0"},{"type":"module","title":"Redlock.ConnectionKeeper","doc":"","ref":"Redlock.ConnectionKeeper.html"},{"type":"function","title":"Redlock.ConnectionKeeper.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Redlock.ConnectionKeeper.html#child_spec/1"},{"type":"function","title":"Redlock.ConnectionKeeper.connection/1","doc":"","ref":"Redlock.ConnectionKeeper.html#connection/1"},{"type":"function","title":"Redlock.ConnectionKeeper.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Redlock.ConnectionKeeper.html#init/1"},{"type":"function","title":"Redlock.ConnectionKeeper.start_link/1","doc":"","ref":"Redlock.ConnectionKeeper.html#start_link/1"},{"type":"module","title":"Redlock.Executor","doc":"","ref":"Redlock.Executor.html"},{"type":"function","title":"Redlock.Executor.extend/3","doc":"","ref":"Redlock.Executor.html#extend/3"},{"type":"function","title":"Redlock.Executor.extend_on_node/5","doc":"","ref":"Redlock.Executor.html#extend_on_node/5"},{"type":"function","title":"Redlock.Executor.lock/2","doc":"","ref":"Redlock.Executor.html#lock/2"},{"type":"function","title":"Redlock.Executor.unlock/2","doc":"","ref":"Redlock.Executor.html#unlock/2"},{"type":"function","title":"Redlock.Executor.unlock_on_node/4","doc":"","ref":"Redlock.Executor.html#unlock_on_node/4"},{"type":"module","title":"Redlock.NodeChooser","doc":"","ref":"Redlock.NodeChooser.html"},{"type":"function","title":"Redlock.NodeChooser.choose/1","doc":"","ref":"Redlock.NodeChooser.html#choose/1"},{"type":"function","title":"Redlock.NodeChooser.init/1","doc":"","ref":"Redlock.NodeChooser.html#init/1"},{"type":"behaviour","title":"Redlock.NodeChooser.Store","doc":"","ref":"Redlock.NodeChooser.Store.html"},{"type":"callback","title":"Redlock.NodeChooser.Store.choose/2","doc":"","ref":"Redlock.NodeChooser.Store.html#c:choose/2"},{"type":"callback","title":"Redlock.NodeChooser.Store.new/1","doc":"","ref":"Redlock.NodeChooser.Store.html#c:new/1"},{"type":"module","title":"Redlock.NodeChooser.Store.HashRing","doc":"","ref":"Redlock.NodeChooser.Store.HashRing.html"},{"type":"module","title":"Redlock.NodeChooser.Store.SingleNode","doc":"","ref":"Redlock.NodeChooser.Store.SingleNode.html"},{"type":"module","title":"Redlock.NodeSupervisor","doc":"","ref":"Redlock.NodeSupervisor.html"},{"type":"function","title":"Redlock.NodeSupervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Redlock.NodeSupervisor.html#child_spec/1"},{"type":"function","title":"Redlock.NodeSupervisor.init/1","doc":"Callback implementation for Supervisor.init/1 .","ref":"Redlock.NodeSupervisor.html#init/1"},{"type":"function","title":"Redlock.NodeSupervisor.start_link/1","doc":"","ref":"Redlock.NodeSupervisor.html#start_link/1"},{"type":"module","title":"Redlock.Supervisor","doc":"","ref":"Redlock.Supervisor.html"},{"type":"function","title":"Redlock.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Redlock.Supervisor.html#child_spec/1"},{"type":"function","title":"Redlock.Supervisor.init/1","doc":"Callback implementation for Supervisor.init/1 .","ref":"Redlock.Supervisor.html#init/1"},{"type":"function","title":"Redlock.Supervisor.start_link/1","doc":"","ref":"Redlock.Supervisor.html#start_link/1"},{"type":"module","title":"Redlock.Util","doc":"","ref":"Redlock.Util.html"},{"type":"function","title":"Redlock.Util.calc_backoff/3","doc":"","ref":"Redlock.Util.html#calc_backoff/3"},{"type":"function","title":"Redlock.Util.log/3","doc":"","ref":"Redlock.Util.html#log/3"},{"type":"function","title":"Redlock.Util.now/0","doc":"","ref":"Redlock.Util.html#now/0"},{"type":"function","title":"Redlock.Util.random_value/0","doc":"","ref":"Redlock.Util.html#random_value/0"},{"type":"extras","title":"Readme","doc":"This library is an implementation of Redlock (Redis destributed lock) Redlock","ref":"readme.html"},{"type":"extras","title":"Readme - Installation","doc":"If available in Hex , the package can be installed by adding redlock to your list of dependencies in mix.exs : def deps do [ { :redlock , &quot;~&gt; 1.0.21&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/redlock .","ref":"readme.html#installation"},{"type":"extras","title":"Readme - Usage","doc":"resource = &quot;example_key: \#{ user_id } &quot; lock_exp_sec = 10 case Redlock . lock ( resource , lock_exp_sec ) do { :ok , mutex } -&gt; # some other code which write and read on RDBMS, KVS or other storage # call unlock finally Redlock . unlock ( resource , mutex ) :error -&gt; Logger . error &quot;failed to lock resource. maybe redis connection got trouble.&quot; { :error , :system_error } end Or you can use transaction function def my_function ( ) do # do something, and return {:ok, :my_result} or {:error, :my_error} end def execute_with_lock ( ) do resource = &quot;example_key: \#{ user_id } &quot; lock_exp_sec = 10 case Redlock . transaction ( resource , lock_exp_sec , &amp; my_function / 0 ) do { :ok , :my_result } -&gt; Logger . info &quot;this is the return-value of my_function/0&quot; :ok { :error , :my_error } -&gt; Logger . info &quot;this is the return-value of my_function/0&quot; :error { :error , :lock_failure } -&gt; Logger . info &quot;if locking has failed, Redlock returns this error&quot; :error end end","ref":"readme.html#usage"},{"type":"extras","title":"Readme - Setup","doc":"children = [ # other workers/supervisors { Redlock , [ pool_size : 2 , ... ] } ] Supervisor . start_link ( children , strategy : :one_for_one )","ref":"readme.html#setup"},{"type":"extras","title":"Readme - Options","doc":"Single Node Mode readlock_opts = [ pool_size : 2 , drift_factor : 0.01 , max_retry : 3 , retry_interval_base : 300 , retry_interval_max : 3_000 , reconnection_interval_base : 500 , reconnection_interval_max : 5_000 , # you must set odd number of server servers : [ [ host : &quot;redis1.example.com&quot; , port : 6379 ] , [ host : &quot;redis2.example.com&quot; , port : 6379 ] , [ host : &quot;redis3.example.com&quot; , port : 6379 ] ] ] pool_size : pool_size of number of connection pool for each Redis master node, default is 2 drift_factor : number used for calculating validity for results, see https://redis.io/topics/distlock for more detail. max_retry : how many times you want to retry if you failed to lock resource. retry_interval_max : (milliseconds) used to decide how long you want to wait untill your next try after a lock-failure. retry_interval_base : (milliseconds) used to decide how long you want to wait untill your next try after a lock-failure. reconnection_interval_base : (milliseconds) used to decide how long you want to wait until your next try after a redis-disconnection reconnection_interval_max : (milliseconds) used to decide how long you want to wait until your next try after a redis-disconnection servers : host, port and auth settings for each redis-server. this amount must be odd. Auth can be omitted if no authentication is reaquired How long you want to wait until your next try after a redis-disconnection or lock-failure the interval(milliseconds) is decided by following calculation. min ( XXX_interval_max , ( XXX_interval_base * ( attempts_count * * 2 ) ) ) Cluster Mode readlock_opts = [ pool_size : 2 , drift_factor : 0.01 , max_retry : 3 , retry_interval_base : 300 , retry_interval_max : 3_000 , reconnection_interval_base : 500 , reconnection_interval_max : 5_000 , cluster : [ # first node [ # you must set odd number of server [ host : &quot;redis1.example.com&quot; , port : 6379 , auth : password ] , [ host : &quot;redis2.example.com&quot; , port : 6379 , auth : password ] , [ host : &quot;redis3.example.com&quot; , port : 6379 , auth : password ] ] , # second node [ # you must set odd number of server [ host : &quot;redis4.example.com&quot; , port : 6379 ] , [ host : &quot;redis5.example.com&quot; , port : 6379 ] , [ host : &quot;redis6.example.com&quot; , port : 6379 ] ] , # third node [ # you must set odd number of server [ host : &quot;redis7.example.com&quot; , port : 6379 ] , [ host : &quot;redis8.example.com&quot; , port : 6379 ] , [ host : &quot;redis9.example.com&quot; , port : 6379 ] ] ] ] Set cluster option instead of servers , then Redlock works as cluster mode. When you want to lock some resource, Redlock chooses a node depends on a resource key with consistent-hashing way (ketama algorithm using md5).","ref":"readme.html#options"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog - [1.0.21] - 2024/03/12","doc":"","ref":"changelog.html#1-0-21-2024-03-12"},{"type":"extras","title":"Changelog - [1.0.20] - 2024/01/18","doc":"Add default database - redix 1.3.0 - nimble_options 1.0 compatibility ( https://github.com/lyokato/redlock/pull/47 ). Thanks to carrascoacd.","ref":"changelog.html#1-0-20-2024-01-18"},{"type":"extras","title":"Changelog - [1.0.19] - 2024/01/18","doc":"CHANGED Allow specification of log level. https://github.com/lyokato/redlock/pull/41/files . Thanks to colin-nl. Drop support for elixir 1.12 and 1.13. https://github.com/lyokato/redlock/pull/43 . Thanks to warmwaffles. Logger.warning instead of Logger.warn. https://github.com/lyokato/redlock/pull/45 . Thanks to warmwaffles. Upgrade redix to 1.3.0. https://github.com/lyokato/redlock/pull/44 . Thanks to warmwaffles.","ref":"changelog.html#1-0-19-2024-01-18"},{"type":"extras","title":"Changelog - [1.0.18] - 2023/04/05","doc":"CHANGED Allow passing socket opts + improve retry logic ( https://github.com/lyokato/redlock/pull/40 ). Thanks to colin-nl.","ref":"changelog.html#1-0-18-2023-04-05"},{"type":"extras","title":"Changelog - [1.0.17] - 2023/04/02","doc":"CHANGED Add extend functionality ( https://github.com/lyokato/redlock/pull/39 ). Thanks to colin-nl.","ref":"changelog.html#1-0-17-2023-04-02"},{"type":"extras","title":"Changelog - [1.0.16] - 2023/02/20","doc":"CHANGED Updates dependencies ( https://github.com/lyokato/redlock/pull/37 ). Thanks to warmwaffles.","ref":"changelog.html#1-0-16-2023-02-20"},{"type":"extras","title":"Changelog - [1.0.15] - 2021/09/03","doc":"CHANGED adds formatter removes warnings for deprecated supervisor() spec definition","ref":"changelog.html#1-0-15-2021-09-03"},{"type":"extras","title":"Changelog - [1.0.14] - 2021/09/03","doc":"CHANGED Bump redix to 1.1.0 ( https://github.com/lyokato/redlock/pull/36 ). Thanks to carrascoacd","ref":"changelog.html#1-0-14-2021-09-03"},{"type":"extras","title":"Changelog - [1.0.13] - 2021/08/21","doc":"CHANGED Avoid max.pow to overflow with values &gt;= 1016 ( https://github.com/lyokato/redlock/pull/35 ). Thanks to carrascoacd","ref":"changelog.html#1-0-13-2021-08-21"},{"type":"extras","title":"Changelog - [1.0.12] - 2020/03/14","doc":"CHANGED Upgrade redix to 0.10.7 ( https://github.com/lyokato/redlock/pull/34 ). Thanks to carrascoacd","ref":"changelog.html#1-0-12-2020-03-14"},{"type":"extras","title":"Changelog - [1.0.10] - 2019/03/01","doc":"CHANGED Fix :milliseconds -&gt; :millisecond ( https://github.com/lyokato/redlock/pull/33 ). Thanks to parallel588","ref":"changelog.html#1-0-10-2019-03-01"},{"type":"extras","title":"Changelog - [1.0.9] - 2019/02/26","doc":"CHANGED Fix authentication( https://github.com/lyokato/redlock/pull/32 ). Thanks to bernardd","ref":"changelog.html#1-0-9-2019-02-26"},{"type":"extras","title":"Changelog - [1.0.8] - 2019/02/25","doc":"CHANGED ex_doc 0.15 -&gt; 0.19","ref":"changelog.html#1-0-8-2019-02-25"},{"type":"extras","title":"Changelog - [1.0.7] - 2019/02/25","doc":"CHANGED add SSL support( https://github.com/lyokato/redlock/pull/30 ). Thanks to bernardd","ref":"changelog.html#1-0-7-2019-02-25"},{"type":"extras","title":"Changelog - [1.0.6] - 2018/11/13","doc":"CHANGED Dyalyzer and test fixed( https://github.com/lyokato/redlock/pull/29 ). Thanks to bernardd","ref":"changelog.html#1-0-6-2018-11-13"},{"type":"extras","title":"Changelog - [1.0.5] - 2018/09/21","doc":"CHANGED update redix to v0.8.1( https://github.com/lyokato/redlock/pull/28 ). Thanks to MihailDV.","ref":"changelog.html#1-0-5-2018-09-21"},{"type":"extras","title":"Changelog - [1.0.4] - 2018/09/06","doc":"CHANGED adds 'database' config param( https://github.com/lyokato/redlock/pull/26 ). Thanks to geofflane.","ref":"changelog.html#1-0-4-2018-09-06"}]